##################################################################################################################################################################
# Version 5.0, Enjoy!
# Release notes:
#
# Chat command for main menu (you decide the command)
# Extra chat command for admin list (you decide the command)
# "New" menu, less confusing, if "confused"
# New menu "Servers" requires Redirect minum version 1.0
##########################################

# Please do not edit below this line it might break the script!
################################################################
# <Modules>
from __future__ import with_statement
# PATH
from path import path

import re
import es
import os
import popuplib
import playerlib
# CONFIG
import cfglib

# Plugin Info
info = es.AddonInfo()
info.author      = "ZZMatty"
info.name        = "Custom Menu"
info.description = "Menu with rules and admins"
info.basename    = "custom_menu"
#
info.version     = "v5"
info.cfgpath     = "config.cfg"

es.ServerVar('custom_menu', info.version, 'Custom Server Menu - Made by %s '%info.author).makepublic()

config = cfglib.AddonCFG(es.getAddonPath(info.basename) + "/" + info.cfgpath)
config.text("    " + info.name + " " + info.version)
config.text("Please remember to edit the command to your need")
config.text("")
chat_command_main = config.cvar("chat_command_main", "!rules", "This is the command used to open the menu")
chat_command_admin = config.cvar("chat_command_admin", "!admins", "This is the command used, to open admin list (Shortcut from main menu)")
advert_show = config.cvar("advert_show", "1", "1 = ON, 0 = OFF. If this feature is enabled make sure to edit below")
advert_tell_what = config.cvar("advert_tell_what", "Open the server menu by typing !rules or !admins to view admins on the server.", "Please edit the text to what you want it to tell every round!")
player_connect = config.cvar("player_connect", "1", "Show menu when a player connects? 1 = Yes, 0 = No")
config.text("")
config.text("***********************************************")
config.write()

# I haven't really tried to make something public but I hope this one work, if you don't mind I will also retype it in def load thank you!
es.makepublic(info.basename)

# Find the file to read
adminListPath = os.path.join( str(es.ServerVar("eventscripts_gamedir")), "addons/eventscripts/custom_menu_d/admin_list.txt")
adminHandle = open(adminListPath, "rb")
adminLines = adminHandle.readlines()
adminHandle.close()

admin = filter(bool, map(lambda x: x[:x.find("//")] if x.find("//") > -1 else x, map(lambda x: x.strip(), adminLines)))

# Repeat new file
ruleListPath = os.path.join( str(es.ServerVar("eventscripts_gamedir")), "addons/eventscripts/custom_menu_d/rule_list.txt")
ruleHandle = open(ruleListPath, "rb")
ruleLines = ruleHandle.readlines()
ruleHandle.close()

# In case: For ignoring //
rule = filter(bool, map(lambda x: x[:x.find("//")] if x.find("//") > -1 else x, map(lambda x: x.strip(), ruleLines)))

# Script load
def load():
    es.msg('#multi', '#default[Custom Menu] #greenhas been loaded. #darkgreenCreated by %s' %info.author)
    es.makepublic(info.basename)
    config.execute()

# Script Unload
def unload():
    es.msg('#multi', '#default[Custom Menu] #greenhas been unloaded. #darkgreenCreated by %s' %info.author)

# When round start what should happen?
def round_start(ev):
    if advert_show == 1:
     es.msg('#multi', '#default[Custom Menu] #green%s' %advert_tell_what)

def player_activate(ev):
    userid = int(ev['userid'])
    if player_connect == 1:
        main(userid)

# Command to open the x menu for input in say_command
def player_say(ev):
    userid = int(ev['userid'])
    player = playerlib.getPlayer(userid)
    if ev['text'] == '%s' %chat_command_main:
        main(userid)
    if ev['text'] == '%s' %chat_command_admins:
        admins(userid)

def main(userid):
    main = popuplib.create('main_menu')
    main.addline('Custom Menu - Created By %s '%info.author)
    main.addline(' ')
    main.addline(' ')
    main.addline('->1. Rules')
    main.addline('->2. Admins')
    main.addline(' ')
    main.addline(' ')
    main.addline('Version 5.0')
    main.addline('0. Exit')
    main.unsend(userid)
    main.send(userid)
    main.delete()
    main.menuselect = mainSelect

def admins(userid):
    admins = popuplib.create('admin_menu_list')
    admins.addline('Custom Menu - Created By %s '%info.author)
    admins.addline('Admin List:')
    admins.addline(' ')
    admins.addline(' ')
    for hook_admins in admin:
     admins.addline(hook_admins)
    admins.addline(' ')
    admins.addline(' ')
    admins.addline('->1. Back')
    admins.addline('0. Exit')
    admins.unsend(userid)
    admins.send(userid)
    admins.delete()
    admins.menuselect = adminsSelect

# Show rules
def rules(userid):
    rules = popuplib.create('rules_menu_list')
    rules.addline('Custom Menu - Created By %s '%info.author)
    rules.addline('Rule List:')
    rules.addline(' ')
    rules.addline(' ')
    for hook_rule in rule:
     rules.addline(hook_rule)
    rules.addline(' ')
    rules.addline(' ')
    rules.addline('->1. Back')
    rules.addline('0. Exit')
    rules.unsend(userid)
    rules.send(userid)
    rules.delete()
    rules.menuselect = rulesSelect

# What should happen when I press 1,2 etc..
def mainSelect(userid, choice, popupid):
    if choice == +0:
      main(userid)
      es.cexec(userid, 'play ui/buttonclick.wav')
    elif choice == 1:
     rules(userid)
     es.cexec(userid, 'play ui/buttonclick.wav')
    elif choice == 2:
     es.cexec(userid, 'play ui/buttonclick.wav')
     admins(userid)
    if choice in (3, 4, 5, 6, 7, 8, 9):
        main(userid)

# <Admins>
def adminsSelect(userid, choice, popupid):
    if choice == 1:
        main(userid)
        es.cexec(userid, 'play ui/buttonclick.wav')
    if choice in (2, 3, 4, 5, 6, 7, 8, 9):
        admins(userid)

# Note
def rulesSelect(userid, choice, popupid):
    if choice == 1:
        main(userid)
        es.cexec(userid, 'play ui/buttonclick.wav')
    if choice in (2, 3, 4, 5, 6, 7, 8, 9):
        rules(userid)

# Let's end the script
#########################
# END OF CUSTOM_MENU Version 5.0
########################
